/*
 * Created on 02.12.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.fhkoeln.fb10.ala.puzzle.algorithm;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author Sanjay
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AStarSearch {
	
	private TreeMap mOpenList = null;
	private TreeMap mClosedList = null;
	private Comparator mProblemComp = null;
	
	public Node solveProblem(Node aStartNode, Node aGoalNode, Comparator aProblemComparator) {
		
		Comparator tSearchComp = new AStarComparator();
		mProblemComp = aProblemComparator;
		
//		initialize the open list
		this.mOpenList = new TreeMap(tSearchComp);
//		initialize the closed list
		this.mClosedList = new TreeMap(tSearchComp);
		
//		put the starting node on the open list (you can leave its f at zero)
		this.putNodeIntoMap(this.mOpenList, aStartNode);
		
		int c = 0;
//		while the open list is not empty
		while (! this.mapIsEmpty(this.mOpenList)) {
			
			c++;

//		    find the node with the least f on the open list, call it "q"
			Node q = this.getFirstNodeFromMap(this.mOpenList);
			//System.out.println(c + ".) -----------------------------");
			//System.out.println("Aktuelles Q:\n" + q);

//		    pop q off the open list
			this.removeNodeFromMap(this.mOpenList, q);
			
//		    generate q's successors and set their parents to q
			Node tSons[] = q.getSons();
			
//		    for each successor
			for (int i=0; i<tSons.length; i++) {

				//System.out.println(i + ". Sohn:\n" + tSons[i]);
				
//		    	if successor is the goal, stop the search
				if (tSons[i].equals(aGoalNode))
					return tSons[i];
				
//		        successor.g = q.g + distance between successor and q
//		        successor.h = distance from goal to successor
//		        successor.f = successor.g + successor.h
				int f = tSons[i].getPathcost() + tSons[i].getGoalDistance();
//
//		        if a node with the same position as successor is in the OPEN list \
//		            which has a lower f than successor, skip this successor
				boolean tSkip = false;
				Node tNode = this.getNodeFromMap(this.mOpenList, tSons[i]);
				if (tNode != null) {
					if (tNode.getGoalDistance() + tNode.getPathcost() < f) {
						tSkip = true;
						//System.out.println(i + ". Sohn in OpenList -> SKIP");
					} else {
						this.removeNodeFromMap(this.mOpenList, tNode);
					}
				}
//		        if a node with the same position as successor is in the CLOSED list \ 
//		            which has a lower f than successor, skip this successor
				tNode = this.getNodeFromMap(this.mClosedList, tSons[i]);
				if (tNode != null) {
					if (tNode.getGoalDistance() + tNode.getPathcost() < f) {
						tSkip = true;
						//System.out.println(i + ". Sohn in ClosedList -> SKIP");
					} else {
						this.removeNodeFromMap(this.mClosedList, tNode);
					}
				}

//				otherwise, add the node to the open list
				if (!tSkip) {
					this.putNodeIntoMap(this.mOpenList, tSons[i]);
					//System.out.println(i + ". Sohn in OpenList hinzugefuegt");
				}
//		    end
			}
			
//		    push q on the closed list
			this.putNodeIntoMap(this.mClosedList, q);
			//System.out.println("\nOpen List:" + this.mOpenList.size());
			//System.out.println("\nClosed List:" + this.mClosedList.size());

//		end
		}
		
		return null; // never reached
		
		
	}
	
	public Long countNodes() {
		Long result = 0l;

		Iterator openIter = mOpenList.values().iterator();
		while (openIter.hasNext()) {
			Map cur = (Map)openIter.next();
			result += cur.size();
		}		

		Iterator closedIter = mClosedList.values().iterator();
		while (closedIter.hasNext()) {
			Map cur = (Map)closedIter.next();
			result += cur.size();
		}		
		
		return result;
	}
	
	private void putNodeIntoMap(TreeMap aMap, Node aNode) {
		Integer costs = aNode.getGoalDistance() + aNode.getPathcost();
		TreeMap problemMap = (TreeMap) aMap.get(costs);
		if(problemMap == null) {
			problemMap = new TreeMap(this.mProblemComp);
			aMap.put(costs, problemMap);
		}
		problemMap.put(aNode, aNode);
		
	}
	
	private void removeNodeFromMap(TreeMap aMap, Node aNode) {
		TreeMap actProblemMap = (TreeMap) aMap.get(aNode.getGoalDistance() + aNode.getPathcost());
		if (actProblemMap.containsKey(aNode)) {
			actProblemMap.remove(aNode);		
		}
		if (actProblemMap.isEmpty()) {
			aMap.remove(aNode.getGoalDistance() + aNode.getPathcost());
		}
	}
	
	private Node getNodeFromMap(TreeMap aMap, Node aNode) {
		Iterator costIterator = aMap.keySet().iterator();
		while (costIterator.hasNext()) {
			TreeMap actProblemMap = (TreeMap) aMap.get(costIterator.next());
			Node tNode = (Node) actProblemMap.get(aNode);
			if (tNode != null)
				return tNode;
		}
		return null;
	}
	
	private Node getFirstNodeFromMap(TreeMap aMap) {
		TreeMap problemMap = (TreeMap) aMap.get(aMap.firstKey());
		return (Node) problemMap.get(problemMap.firstKey());
	}
	
	private boolean mapIsEmpty(TreeMap aMap) {
		Iterator costIterator = aMap.keySet().iterator();
		while (costIterator.hasNext()) {
			TreeMap actProblemMap = (TreeMap) aMap.get(costIterator.next());
			if (!actProblemMap.isEmpty())
				return false;
		}
		return true;		
	}
	
	
	
	
	
	
	
	
/*	

	private IWrapperNode getNodeFromMap(HashMap aList, IWrapperNode aNode) {
		Iterator nodesIter = aList.keySet().iterator();
		while (nodesIter.hasNext()) {
			IWrapperNode tNode = (IWrapperNode) nodesIter.next();
			if (aNode.equals(tNode))
				return tNode;
		}
		return null;
	}
	
*/
	
	private void printList(HashMap aList) {
		Iterator nodesIter = aList.keySet().iterator();
		while (nodesIter.hasNext()) {
			Node tNode = (Node) nodesIter.next();
			System.out.print(tNode.getGoalDistance() + tNode.getPathcost() + "|");
		}
	}
	
	/**
	 * @param map
	 * @return
	 */
	/*	
	private IWrapperNode getFirstFromMap(HashMap aMap) {

		Iterator nodesIter = aMap.keySet().iterator();

		IWrapperNode rMinNode = null;
		int tMin = 0;
		if (nodesIter.hasNext()) {
			rMinNode = (IWrapperNode) nodesIter.next();
			tMin = rMinNode.getGoalDistance() + rMinNode.getPathcost();
		}

		while (nodesIter.hasNext()) {
			IWrapperNode tNode = (IWrapperNode) nodesIter.next();
			if (tNode.getGoalDistance() + tNode.getPathcost() < tMin) {
				tMin = tNode.getGoalDistance() + tNode.getPathcost();
				rMinNode = tNode;
			}
		}
		
		return rMinNode;
	}
*/

}
