package de.fhkoeln.fb10.ala.puzzle.algorithm;

import de.fhkoeln.fb10.ala.puzzle.domain.Position;
import de.fhkoeln.fb10.ala.puzzle.domain.Puzzle;

public class ManhattenHeuristicImpl implements Heuristic {

	public int calculateHeuristic(Puzzle aActState, Puzzle aGoalState) throws IllegalArgumentException {
		
		if (aActState.getSize() != aGoalState.getSize())
			throw new IllegalArgumentException("Sizes of agument states are different");
		
		int[][] tActStateArray = aActState.getState();
		//int[][] tGoalStateArray = aGoalState.getState();
		
		int size = aActState.getSize();
		
		int rHeuristicSum = 0;
		for (int l=0; l<size; l++) {
			for (int r=0; r<size; r++) {
				if (tActStateArray[l][r] != Puzzle.KEY_BLANK_STONE) {
					Position tGoalPos = aGoalState.getPositionOf(tActStateArray[l][r]);
					rHeuristicSum += tGoalPos.distance(l, r);
				}
			}
		}
		
		return rHeuristicSum;
	}
	
	/*private int distance(int l1, int r1, int l2, int r2) {
		return Math.abs(l1 - l2) + Math.abs(r1 - r2);		
	}*/
	
}
