/*
 * Created on 02.12.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.fhkoeln.fb10.ala.puzzle.algorithm;

import de.fhkoeln.fb10.ala.puzzle.domain.Puzzle;

/**
 * @author Sanjay
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PuzzleNodeImpl implements Node {
	
	private static Puzzle mGoalState = null;
	private static Heuristic mHeuristic = null;
	
	Puzzle mState = null;
	int mGoalDistance = -1;
	int mPathCost = -1;
	PuzzleNodeImpl mFather = null;
	
	public PuzzleNodeImpl(Puzzle aState, Puzzle aGoal, Heuristic aHeuristic) {
		if (aHeuristic == null || aState == null || aGoal == null)
			throw new IllegalArgumentException();

		PuzzleNodeImpl.mGoalState = aGoal;
		PuzzleNodeImpl.mHeuristic = aHeuristic;
		this.setState(aState);
		this.mPathCost = 0;
	}
	
	private PuzzleNodeImpl(Puzzle aState, PuzzleNodeImpl aFather) {
		this.setState(aState);
		this.setFather(aFather);
	}
	
	private void setState(Puzzle aState) {
		if (aState == null)
			throw new IllegalArgumentException();
		this.mState = aState;
		this.setGoalDistance();
	}

	private void setFather(PuzzleNodeImpl aFather) {
		if (aFather == null)
			throw new IllegalArgumentException();
		this.mFather = aFather; 
		this.mPathCost = this.mFather.getPathcost() + 1;
	}
	
	private void setGoalDistance() {
		if (this.mState == null || PuzzleNodeImpl.mGoalState == null)
			throw new IllegalArgumentException("Or state or goal state is not set");
		this.mGoalDistance = PuzzleNodeImpl.mHeuristic.calculateHeuristic(this.mState, PuzzleNodeImpl.mGoalState);
	}
	

	/* (non-Javadoc)
	 * @see puzzle.IPuzzleState#setGoalDistance(int)
	 */
	public void setGoalDistance(int aVal) {
		if (aVal >= 0)
			this.mGoalDistance = aVal;
		else
			throw new IllegalArgumentException();
	}

	/* (non-Javadoc)
	 * @see puzzle.IPuzzleState#getGoalDistance()
	 */
	public int getGoalDistance() {
		return this.mGoalDistance;
	}
	
	public int getStateSize() {
		return this.mState.getSize();
	}
	
	public Puzzle getState() {
		return this.mState;
	}

	/* (non-Javadoc)
	 * @see algorithm.IWrapperNode#getSons()
	 */
	public Node[] getSons() {
		Puzzle tSons[] = this.mState.getSons();
		Node rSons[] = new PuzzleNodeImpl[tSons.length];
		for (int i=0; i<tSons.length; i++) {
			rSons[i] = new PuzzleNodeImpl(tSons[i], this);
		}
		return rSons;
	}
	
	/* (non-Javadoc)
	 * @see algorithm.IWrapperNode#getPathcost()
	 */
	public int getPathcost() {
		return this.mPathCost;
	}

	/* (non-Javadoc)
	 * @see algorithm.IWrapperNode#getFather()
	 */
	public Node getFather() {
		return this.mFather;
	}
	
	public String toString() {
		String rString = this.mState.toString();
		rString += "Path Cost: " + this.mPathCost + " Goal Distance: " + this.mGoalDistance;
		return rString;
	}

	public boolean equals(Object obj) {
		if(obj != null)
			return this.mState.equals(((PuzzleNodeImpl)obj).mState);
		else return super.equals(obj);
	}

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object arg0) {
		return this.mState.compareTo(((PuzzleNodeImpl)arg0).getState());
	}
	


}
