package de.fhkoeln.fb10.ala.puzzle.domain;

public interface Puzzle {
	
	/**
	 * Directions
	 */
	public static final int DIR_NONE = 0;
	
	public static final int DIR_UP = 1;
	public static final int DIR_DOWN = 2;
	public static final int DIR_LEFT = 3;
	public static final int DIR_RIGHT = 4;
	
	public static final int KEY_BLANK_STONE = -1;
	
	/**
	 * Returns the puzzle state
	 * @return Double Array of int with values ordered in n*n matrix 
	 */
	public int[][] getState();
	
	/**
	 * Returns a default goal state for this puzzle with descending order the 
	 * the keys 1,2,3,4,Blank
	 * @return
	 */
	public int[][] getDefaultGoalState();

	/**
	 * Sets the puzzle state
	 * @param state
	 */
	//public void setState(int[][] state);
	
	/**
	 * Returns the size of the State (returns n of the n*n matrix)
	 * @return size of the State
	 */
	public int getSize();
	
	public Position getPositionOf(int aKey) throws IllegalArgumentException;
	
	
	/**
	 * Returns all Puzzle States which can be created through one move
	 * @return
	 */
	public Puzzle[] getSons();
	
	public int compareTo(Puzzle aState);

	public void setSize(int i);
	
	public boolean moveBlank(int direction);
	
}
