package de.fhkoeln.fb10.ala.puzzle.ui;

import java.awt.BorderLayout;
import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class CellPane extends JPanel {

	private static final long serialVersionUID = 8672799614090132108L;

	private Integer key;
	private PuzzlePane puzzlePane;
	private JLabel label = null;
	
	private Image image;
	
	public CellPane(Integer key) {
		super();
		this.key = key;
	}

	public void initialize() {
		
		if(image == null){
			label = new JLabel();
			label.setFont(new java.awt.Font("Arial Black", java.awt.Font.BOLD | java.awt.Font.ITALIC, 15));
			label.setText(this.key.toString());
			label.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
			label.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		} else {
			label = new JLabel(new ImageIcon(getImage()));
		}
		this.setLayout(new BorderLayout());
		this.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		this.setBackground(java.awt.Color.white);

		this.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				move();
			}
			public void mouseEntered(MouseEvent e) {

			}
		});
		this.add(label, java.awt.BorderLayout.CENTER);		
	}

	public void move() {
		this.puzzlePane.moveCell(this);
	}
	
	public PuzzlePane getPuzzlePane() {
		return puzzlePane;
	}

	public void setPuzzlePane(PuzzlePane puzzlePane) {
		this.puzzlePane = puzzlePane;
	}

	public Integer getKey() {
		return key;
	}

	public void setKey(Integer key) {
		this.key = key;
	}

	public Image getImage() {
		return image;
	}

	public void setImage(Image image) {
		this.image = image;
	}
}
