package de.fhkoeln.fb10.ala.puzzle.ui;

import java.awt.BorderLayout;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;

import org.apache.log4j.AppenderSkeleton;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.apache.log4j.spi.LoggingEvent;

public class LogPane extends JPanel {

	private static final long serialVersionUID = 6229894958340557491L;

	private String title = "Log Pane";

	private JTextArea logTextArea;

	private String logLayout; 
	
	private class TextAreaLogger extends AppenderSkeleton {

		protected void append(LoggingEvent aEvent) {
			logTextArea.append(getLayout().format(aEvent) + "\n");
			logTextArea.setCaretPosition( logTextArea.getDocument().getLength() );
		}

		public void close() {
			// TODO Auto-generated method stub
		}

		public boolean requiresLayout() {
			return true;
		}
	}
	
	public void initialize() {
		TitledBorder titledBorder = BorderFactory.createTitledBorder(null, this.title , TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null);
		titledBorder.setTitleFont(new Font("Arial", java.awt.Font.PLAIN, 10));
		setBorder(titledBorder);
		
		setLayout(new BorderLayout());
		
		logTextArea = new JTextArea();
		
		JScrollPane scroller = new JScrollPane();
		scroller.add(logTextArea);
		
		TextAreaLogger textAreaLogger = new TextAreaLogger();
		textAreaLogger.setLayout(new PatternLayout(logLayout));

		Logger.getRoot().addAppender(textAreaLogger);
		
		JScrollPane scrollPane = new JScrollPane(logTextArea);
		
		add(scrollPane, BorderLayout.CENTER);
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getLogLayout() {
		return logLayout;
	}

	public void setLogLayout(String logLayout) {
		this.logLayout = logLayout;
	}
}
