package de.fhkoeln.fb10.ala.puzzle.ui;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class MainFrame extends JFrame {

	private Log log = LogFactory.getLog(PuzzlePane.class);

	private static final long serialVersionUID = -4632887450867806092L;

	private int width;
	private int height;
	
	private Integer padding;
	
	private PuzzlePane puzzlePane;
	private ControllerPane controllerPane;
	private LogPane logPane;

	public MainFrame() {
	}

	public void initialize() {
		GridBagLayout gridBag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
		
        setLayout(gridBag);
        c.insets = new Insets(padding,padding,padding,padding);
        c.gridwidth = 2;
        c.gridheight = 2;
  	   	c.fill = GridBagConstraints.BOTH;
        c.weighty = 0.66;  	   	
        
        gridBag.setConstraints(controllerPane,c);
        this.getContentPane().add(controllerPane);

        c.insets = new Insets(padding,0,padding,padding);
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.BOTH;
  	   	c.weightx = 1;

        gridBag.setConstraints(puzzlePane,c);
        this.getContentPane().add(puzzlePane);
 
        c.insets = new Insets(0,padding,padding,padding);
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;

        gridBag.setConstraints(logPane, c);
        this.getContentPane().add(logPane);
        
        setSize(new Dimension(width, height));
        
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		
		setState(Frame.NORMAL);
		setVisible(true);
		puzzlePane.drawPuzzle();
		
	}

	public PuzzlePane getPuzzle() {
		return puzzlePane;
	}

	public void setPuzzlePane(PuzzlePane puzzle) {
		this.puzzlePane = puzzle;
	}
	
	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public ControllerPane getControllerPane() {
		return controllerPane;
	}

	public void setControllerPane(ControllerPane controllerPane) {
		this.controllerPane = controllerPane;
	}

	public PuzzlePane getPuzzlePane() {
		return puzzlePane;
	}

	public Integer getPadding() {
		return padding;
	}

	public void setPadding(Integer padding) {
		this.padding = padding;
	}

	public LogPane getLogPane() {
		return logPane;
	}

	public void setLogPane(LogPane logPane) {
		this.logPane = logPane;
	}


}
