package de.fhkoeln.fb10.ala.puzzle.test;

import java.util.Arrays;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import junit.framework.TestCase;
import de.fhkoeln.fb10.ala.puzzle.algorithm.ManhattenHeuristicImpl;
import de.fhkoeln.fb10.ala.puzzle.domain.AStarPuzzleSolver;
import de.fhkoeln.fb10.ala.puzzle.domain.Puzzle;
import de.fhkoeln.fb10.ala.puzzle.domain.PuzzleImpl;
import de.fhkoeln.fb10.ala.puzzle.ui.PuzzlePane;

public class AStarSolverTest extends TestCase {

	private Log log = LogFactory.getLog(AStarSolverTest.class);
	
	public void testSolve() {
		
		AStarPuzzleSolver aSS = new AStarPuzzleSolver();
		int startArray[][] = {{4, 7, 5},
				{1, Puzzle.KEY_BLANK_STONE, 8},
				{6, 2, 3}};

		PuzzleImpl p = new PuzzleImpl(startArray);
		aSS.setPuzzle(p);
		aSS.setHeuristic(new ManhattenHeuristicImpl());
		List<Integer> l = aSS.solve();
		
		for (Integer cur : l) {
			//p.moveBlank(cur);
			p.move(cur);
		}
		
		log.debug("Resulting key moves: " + l.toString());
		
		//assertTrue(true);
		assertTrue(Arrays.deepEquals(p.getDefaultGoalState(),p.getState()));
	}
}
